# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

from ._models import AuthorizationRule
from ._models import CreateQueueBody
from ._models import CreateQueueBodyContent
from ._models import CreateRuleBody
from ._models import CreateRuleBodyContent
from ._models import CreateSubscriptionBody
from ._models import CreateSubscriptionBodyContent
from ._models import CreateTopicBody
from ._models import CreateTopicBodyContent
from ._models import EmptyRuleAction
from ._models import FalseFilter
from ._models import KeyValue
from ._models import MessageCountDetails
from ._models import NamespaceProperties
from ._models import NamespacePropertiesEntry
from ._models import NamespacePropertiesEntryContent
from ._models import QueueDescription
from ._models import QueueDescriptionEntry
from ._models import QueueDescriptionEntryContent
from ._models import QueueDescriptionFeed
from ._models import ResponseAuthor
from ._models import ResponseLink
from ._models import RuleAction
from ._models import RuleDescription
from ._models import RuleDescriptionEntry
from ._models import RuleDescriptionEntryContent
from ._models import RuleDescriptionFeed
from ._models import RuleFilter
from ._models import ServiceBusManagementError
from ._models import SqlFilter
from ._models import SqlRuleAction
from ._models import SubscriptionDescription
from ._models import SubscriptionDescriptionEntry
from ._models import SubscriptionDescriptionEntryContent
from ._models import SubscriptionDescriptionFeed
from ._models import TopicDescription
from ._models import TopicDescriptionEntry
from ._models import TopicDescriptionEntryContent
from ._models import TopicDescriptionFeed
from ._models import TrueFilter

from ._enums import AccessRights
from ._enums import EntityAvailabilityStatus
from ._enums import EntityStatus
from ._enums import MessagingSku
from ._enums import NamespaceType
from ._patch import __all__ as _patch_all
from ._patch import *  # pylint: disable=unused-wildcard-import

# manually delete imports from generated models and import directly from patch for correct typing
from ._patch import patch_sdk as _patch_sdk, CorrelationFilter, KeyObjectValue

__all__ = [
    "AuthorizationRule",
    "CorrelationFilter",
    "CreateQueueBody",
    "CreateQueueBodyContent",
    "CreateRuleBody",
    "CreateRuleBodyContent",
    "CreateSubscriptionBody",
    "CreateSubscriptionBodyContent",
    "CreateTopicBody",
    "CreateTopicBodyContent",
    "EmptyRuleAction",
    "FalseFilter",
    "KeyObjectValue",
    "KeyValue",
    "MessageCountDetails",
    "NamespaceProperties",
    "NamespacePropertiesEntry",
    "NamespacePropertiesEntryContent",
    "QueueDescription",
    "QueueDescriptionEntry",
    "QueueDescriptionEntryContent",
    "QueueDescriptionFeed",
    "ResponseAuthor",
    "ResponseLink",
    "RuleAction",
    "RuleDescription",
    "RuleDescriptionEntry",
    "RuleDescriptionEntryContent",
    "RuleDescriptionFeed",
    "RuleFilter",
    "ServiceBusManagementError",
    "SqlFilter",
    "SqlRuleAction",
    "SubscriptionDescription",
    "SubscriptionDescriptionEntry",
    "SubscriptionDescriptionEntryContent",
    "SubscriptionDescriptionFeed",
    "TopicDescription",
    "TopicDescriptionEntry",
    "TopicDescriptionEntryContent",
    "TopicDescriptionFeed",
    "TrueFilter",
    "AccessRights",
    "EntityAvailabilityStatus",
    "EntityStatus",
    "MessagingSku",
    "NamespaceType",
]
__all__.extend([p for p in _patch_all if p not in __all__])
_patch_sdk()
